module Pkgman
  module Builds
    class Source

      attr_reader :build

      def initialize(build, target)
        @build = build
        @target = target
      end

      def start
        @target.execute("curl -o source.tar.gz #{build['source']}", '/tmp/src')
        @target.execute('tar -xf source.tar.gz', '/tmp/src')

        unless build['source-directory']
          uri = URI(build['source'])

          build['source-directory'] = File.basename(uri.path, ".*")
          if build['source-directory'].end_with?('.tar')
            build['source-directory'] = File.basename(build['source-directory'], ".tar")
          end
        end

        build['configure'] ||= []
        unless build['configure'].find { |it| it.start_with?('--prefix=') }
          build['configure'] << '--prefix=/usr'
        end

        dir = "/tmp/src/#{build['source-directory']}"
        @target.execute("./configure #{build['configure'].join(' ')}", dir)
        @target.execute('make install DESTDIR=/tmp/compiled', dir)
      end

      def type
        'dir'
      end

      def path
        '/tmp/compiled'
      end

    end
  end
end