require 'yaml'
require 'liquid'

module Pkgman
  class Descriptor

    def initialize(path = 'pkgman.yml')
      @path = path
      @data = Wrapper.new.merge(YAML.load(File.read(File.expand_path(@path))))
    end

    def [](name)
      @data[name]
    end

    class Wrapper < Hash

      def [](name)
        val = super(name)
        case val
        when Hash
          self[name] = Wrapper.new.merge(val) unless val.kind_of?(Wrapper)
          super(name)
        when Array
          self[name] = val.map { |it| it.kind_of?(Hash) ? Wrapper.new.merge(it) : it }
          super(name)
        when String
          Liquid::Template.parse(val).render(self)
        else
          val
        end
      end

    end

  end
end