module Pkgman
  module Packages

    class Rpm

      attr_reader :package

      def initialize(build, package, target)
        @build = build
        @package = package
        @target = target
      end

      def name
        @build.build['name']
      end

      def version
        @build.build['version']
      end

      def start
        deps = '-d ' + @package['dependencies'].join(' -d ')

        cmd = "fpm -n #{name} "
        cmd += "-v #{version} "
        cmd += "-s #{@build.type} -t rpm #{deps} "
        cmd += "-p /tmp/product -C #{@build.path}"

        @target.execute(cmd)
      end

      def path
        "/tmp/product/#{name}-#{version}-1.x86_64.rpm"
      end

      def type
        'rpm'
      end

    end

  end
end