require 'pkgman/targets/centos'

module Pkgman
  class Target

    attr_reader :target

    def initialize(runtime, target)
      @target = target
      case @target['image']
        when 'centos'
          @driver = Targets::Centos.new(runtime, target)
      end
    end

    def execute(*args, &block)
      @driver.container.execute(*args, &block)
    end

    def download(*args, &block)
      @driver.container.download(*args, &block)
    end

    def destroy
      @driver.container.destroy
    end

  end
end