module Pkgman
  module Targets
    class Centos

      attr_reader :container

      def initialize(runtime, target)
        @runtime = runtime
        @target = target

        @container = runtime.container(target['image'], target['version'])

        self.update
        self.install('gcc', 'bzip2', 'make', 'rpm-build', 'rubygems', 'ruby-devel', 'ruby-json')

        @container.execute('gem install --no-document fpm')

        self.install(*target['requires'])

        @container.execute('mkdir -p /tmp/compiled')
        @container.execute('mkdir -p /tmp/src')
        @container.execute('mkdir -p /tmp/product')
      end

      def update
        @container.execute('yum update -y --setopt=tsflags=nodocs')
      end

      def install(*packages)
        pkgs = packages.join(' ')
        @container.execute("yum install -y --setopt=tsflags=nodocs #{pkgs}")
      end

    end

  end
end